#!/usr/bin/env bash
	
SOC_FAN_ON_TEMP=50
SOC_FAN_OFF_TEMP=40
HDD_FAN_ON_TEMP=60
HDD_FAN_OFF_TEMP=45
PIN_SOCFAN=22
PIN_HDDFAN=23
DEV_HDD=/dev/sda
	
set -e
	
TEMP_SOC=$(($(cat /sys/class/thermal/thermal_zone0/temp) / 1000))
TEMP_HDD=$(sudo smartctl -A "$DEV_HDD" | fgrep Temperature_Celsius | awk '{print $10}')
	
do_ops() {
	PIN="$1"
	TEMP="$2"
	ON_TEMP="$3"
	OFF_TEMP="$4"
	if [ -n "$TEMP" ]; then
		gpio -g mode "$PIN" out
		if [ "$TEMP" -ge "$ON_TEMP" ]; then
			gpio -g write "$PIN" 1
		elif [ "$TEMP" -le "$OFF_TEMP" ]; then
			gpio -g write "$PIN" 0
		fi
	fi
}
	
do_ops "$PIN_SOCFAN" "$TEMP_SOC" "$SOC_FAN_ON_TEMP" "$SOC_FAN_OFF_TEMP"
do_ops "$PIN_HDDFAN" "$TEMP_HDD" "$HDD_FAN_ON_TEMP" "$HDD_FAN_OFF_TEMP"
